=== github.com/docker/docker-credential-helpers@v0.7.0/deb/debian/control ===
Source: docker-credential-helpers
Section: admin
Priority: optional
Maintainer: Docker <support@docker.com>
Homepage: https://dockerproject.org
Standards-Version: 3.9.6
Vcs-Browser: https://github.com/docker/docker-credential-helpers
Vcs-Git: git://github.com/docker/docker-credential-helpers.git
Build-Depends: debhelper
  , dh-make
  , libsecret-1-dev

Package: docker-credential-secretservice
Architecture: any
Depends: libsecret-1-0
  , ${misc:Depends}
Description: docker-credential-secretservice is a credential helper backend
 which uses libsecret to keep Docker credentials safe.

Package: docker-credential-pass
Architecture: any
Depends: pass
  , ${misc:Depends}
Description: docker-credential-secretservice is a credential helper backend
 which uses the pass utility to keep Docker credentials safe.
